<template>
  <div>
    <div class="row">
      <div class="col-md-12" v-if="filter.filters">
        <SearchFilter :filter="filter"></SearchFilter>
      </div>
    </div>
    <div class="custom-container">
      <div class="row">
        <div class="col-sm-12 col-md-9">
          <div class="row">
            <div class="col-6">
              <div v-if="totalJobs" style="color: black;margin-top: 30px;">
            {{totalJobs}} results found for "<span style="color:#EF6363">{{query}}</span>"
            </div>
            <div v-else style="color: black; margin-top: 30px; margin-bottom: 30px;margin-left:15px">
              0 result found for "<span style="color:#EF6363"> {{query}} </span>"
            </div>
            </div>
            <div v-if="totalJobs" class="col-6">

                <button
                v-on:click="filter.filters = !filter.filters"
                v-if="filter.filters"
                class="position position1 btncolorclose">Close Filters
                </button>

                <button
                v-on:click="filter.filters = !filter.filters"
                v-else
                class="position position1 btncoloropen">
                Filter Result
                </button>

              <div style="margin-top:30px">
             <span v-on:click="isHiddenSort = !isHiddenSort" class="sort-btn">Sort By: <a class="sort-link">{{sortLabel}}</a></span>
            </div>
              <div class="form-control category2-options toogle-div" v-if="!isHiddenSort" style="z-index:20;">
                  <ul>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value=""
                      />Relevance
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="last-modified"
                      />Last Modified
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="job-title-asc"
                      />Job Title (A to Z)
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="job-title-desc"
                      />Job Title (Z to A)
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="base-rate-asc"
                      />Pay Rate (Low to High)
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="base-rate-desc"
                      />Pay Rate (High to Low)
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="exp-asc"
                      />Experience (Low to High)
                    </li>
                    <li class="categry2-options-li">
                      <input
                        class="mr-2 leading-tight"
                        v-model="sortStatus"
                        type="radio"
                        value="exp-desc"
                      />Experience (High to Low)
                    </li>
                  </ul>
              </div>

            </div>
          </div>
          <div class="col-12">
            <div v-if="paginateJobs.length > 0" class="row">
              <SearchJobCard
                v-for="job in paginateJobs"
                :job="job"
                :key="job.id"
                :user="user"
                @calculate-rate="calculateRate"
                @refresh-jobs="fetchAPI"
              />
            </div>
            <div  v-else class="container">
              <h3 class="row">These are not the droids you are looking for!</h3>
              <p class="row" style="color:black;"><br>You may have a better luck searching for them if you type:<br>e.g.: US_199 for candidate ID <br>e.g.: ABAP, SAP FI, MM, Oil and Gas, Automotive for skill set and/or industry</p>
          </div>
          </div>
          <SearchPagination
            v-if="paginateJobs.length > 0"
            :pageNumber="pageNumber"
            :totalPages="totalPages"
            :minPage="minPage"
            :maxPage="maxPage"
            @change-page="setPage"
          />
        </div>

        <div v-if="totalJobs" class="col-sm-12 col-md-3 space-top">
          <RateCalculator :calculateValue="calculateValue" />
          <doYouKnow />
        </div>
      </div>
      </div>
    <notifications group="foo" />
  </div>
</template>

<script>
import moment from "moment";
import api from "../../api/jobs";
import SearchFilter from "./SearchFilter.vue";
import SearchPagination from "./SearchPagination.vue";
import SearchJobCard from "./SearchJobCard.vue";
import RateCalculator from "./RateCalculator.vue";
import doYouKnow from "./doYouKnow.vue";

export default {
  props: {
    user: {
      required: false
    }
  },
  components: {
    SearchFilter,
    SearchPagination,
    SearchJobCard,
    doYouKnow
  },
  data() {
    return {
      filter: {
        filters: false,
        job_mode: [],
        job_type: [],
        category: [],
        baseRate: {
          from: null,
          to: null
        },
        work_experience: [],
        industry: [],
        state: [],
        date: [],
        durations: []
      },
      sortStatus: null,
      jobs: [],
      size: 15,
      pageNumber: 0,
      calculateValue: 1000,
      isHiddenSort:true

    };
  },
  methods: {
    fetchAPI() {
      var query = window.location.search;
      api
        .getJobs(query || "")
        .then(res => {
          // console.log(res.data);
          this.jobs = res.data;
        })
        .catch(err => {
          console.log(err);
        });
    },

    setPage(page) {
      this.pageNumber = page;
    },

    calculateRate(rate) {
      this.calculateValue = rate;
    }
  },
  mounted() {
    this.fetchAPI();
  },
  computed: {
    sortLabel(){
     if(this.sortStatus == null || this.sortStatus == ""){
        return "Relevance";
     }
     if(this.sortStatus == "last-modified"){
        return "Last Modified";
     }
      if(this.sortStatus == "job-title-asc"){
        return "Job Title (A to Z)";
     }
     if(this.sortStatus == "job-title-desc"){
        return "Job Title (Z to A)";
     }
     if(this.sortStatus == "base-rate-asc"){
        return "Pay Rate (Low to High)";
     }
     if(this.sortStatus == "base-rate-desc"){
        return "Pay Rate (High to Low)";
     }
     if(this.sortStatus == "exp-asc"){
        return "Experience (Low to High)";
     }
     if(this.sortStatus == "exp-desc"){
        return "Experience (High to Low)";
     }
   },
    filterJobs() {
      var result = this.jobs;
      for (var key in this.filter) {
        result = result.filter(job => {
          if (!this.filter[key].length && key !== "baseRate") return true;

          //If filter category
          if (key === "category") {
            var jobCategory = job.category.split(",");
            jobCategory = jobCategory.map(job => {
              return job.toUpperCase();
            });
            //if (this.filter.category.includes(jobCategory)) return true;

            var checkDuplicate = this.filter.category.filter(cat => {
              return jobCategory.indexOf(cat) != -1;
            });

            if (checkDuplicate.length > 0) {
              return true;
            }
            return false;
          }

          // If base Rate
          if (key === "baseRate") {
            if (!this.filter.baseRate.from )
              return true;
            var jobRate = parseFloat(job.job_base_rate);
            if (
              jobRate >= this.filter.baseRate.from 
            ) {
              return true;
            } else {
              return false;
            }
          }

          if (key === "durations") {
            var status = false;
            this.filter.durations.forEach(filterDate => {
              if (filterDate == -1) status = true;
              else if (job.job_duration <= filterDate) status = true;
            });
            if (status) {
              return true;
            } else {
              return false;
            }
          }

          if (key === "date") {
            var date = moment(job.date_opened);
            var today = moment(new Date());
            var differentDate = today.diff(date, "day");

            var status = false;

            this.filter.date.forEach(filterDate => {
              if (differentDate <= filterDate) status = true;
            });

            if (status) {
              return true;
            } else {
              return false;
            }
          }

          if (this.filter[key].includes(job[key].toUpperCase())) return true;

          return false;
        });
      }

      if (this.sortStatus == "last-modified") {
        result = result.sort((a, b) => (a.updated_at > b.updated_at ? 1 : -1));
      }

      if (this.sortStatus == "job-title-asc") {
        result = result.sort((a, b) =>
          a.posting_title > b.posting_title ? 1 : -1
        );
      }

      if (this.sortStatus == "job-title-desc") {
        result = result.sort((a, b) =>
          a.posting_title < b.posting_title ? 1 : -1
        );
      }

      if (this.sortStatus == "base-rate-asc") {
        result = result.sort((a, b) =>
          a.job_base_rate > b.job_base_rate ? 1 : -1
        );
      }

      if (this.sortStatus == "base-rate-desc") {
        result = result.sort((a, b) =>
          a.job_base_rate < b.job_base_rate ? 1 : -1
        );
      }
       if (this.sortStatus == "exp-asc") {
        result = result.sort((a, b) =>
          a.experience_in_years > b.experience_in_years ? 1 : -1
        );
      }

      if (this.sortStatus == "exp-desc") {
        result = result.sort((a, b) =>
          a.experience_in_years < b.experience_in_years ? 1 : -1
        );
      }

      return result;
    },
    paginateJobs() {
      let start = this.pageNumber * this.size;
      let end = start + this.size;
      return this.filterJobs.slice(start, end);
    },
    checkquery() {
      var param = new URLSearchParams(location.search);

      if (
        typeof param.get("jobsearchterm") == "undefined" ||
        param.get("jobsearchterm")
      ) {
        return false;
      } else {
        return true;
      }
    },
    query() {
      let param = new URLSearchParams(location.search);
      return param.get("jobsearchterm");
    },
    currentPage() {
      var jobReminder = (this.pageNumber + 1) * this.size;
      if (jobReminder > this.totalJobs) return (jobReminder = this.totalJobs);

      return jobReminder;
    },

    totalJobs() {
      return this.filterJobs.length;
    },
    totalPages() {
      return Math.ceil(this.totalJobs / this.size);
    },
    minPage() {
      return this.pageNumber + 1 !== 1;
    },
    maxPage() {
      return this.pageNumber + 1 !== this.totalPages;
    }
  },
  watch: {
    filter(val) {
      console.log(val);
    }
  }
};
</script>

<style>
.side-spacing {
  margin-left: 100px;
  margin-right: 100px;
}

.space-top {
  margin-top: 75px;
}

.container {
  padding-right: 15px;
  padding-left: 15px;
  margin-right: auto;
  margin-left: auto;
}

@media (min-width: 768) {
  #wrapper .container {
    max-width: 100%;
    display: block;
  }
}

.custom-container {
  margin-right: 20px;
  margin-left: 20px;
}

.color2 {
  color: #3c3c3c;
}

.position1 {
  margin: 20px;
}

.btncoloropen {
  font-size: 14px;
  background-color: #ef6363;
  border: 0px !important;
  font-weight: 400 !important;
}
.btncolorclose {
  font-weight: 400 !important;
  color: #ef6363;
  font-size: 14px;
  background-color: white !important;
  border: 2px solid;
}
.sort-btn{
  
  border:none;
  font-size:14px;
  color:black;
  background-color: transparent;
}
.reset-hover:hover{
background-color: transparent;
color:black;
}
.sort-link{
  
  color:#F78E24!important;
  text-decoration: underline;
}
.sort-link:hover{
  color: #EF6363!important;
}
</style>